<template>
  <Dialog v-model="dialogVisible" title="商家备注" width="70%" >
    <div style="max-height:500px;overflow-y:auto;padding: 10px;" v-if="showDetail"> 
      <OrderBaseInfo ref="infoRef" :is-detail="true" :id="formData.id" style="margin-bottom:30px" />
      <OrderProduct ref="infoRef" :is-detail="isDetail" :id="formData.id" />
    </div>
    <el-form ref="formRef" v-loading="formLoading" :model="formData" label-width="80px" style="padding: 10px;" v-else>
        <el-form-item label="备注">
          <el-input
            v-model="formData.remark"
            :rows="3"
            placeholder="请输入订单备注"
            type="textarea"
          />
        </el-form-item>
      </el-form>
    <template #footer>
      <el-form ref="formRef" v-loading="formLoading" :model="formData" label-width="80px" v-if="showDetail">
        <el-form-item label="备注">
          <el-input
            v-model="formData.remark"
            :rows="3"
            placeholder="请输入订单备注"
            type="textarea"
          />
        </el-form-item>
      </el-form>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script lang="ts" setup>
import * as TradeOrderApi from '@/api/mall/trade/order'
import OrderBaseInfo from '../components/OrderBaseInfo.vue'
import OrderProduct from '../components/OrderProduct.vue'
defineOptions({ name: 'OrderUpdateRemarkForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formData = ref({
  id: 0, // 订单编号
  remark: '' // 订单备注
})
const formRef = ref() // 表单 Ref
const showDetail = ref(true) // 是否显示详情
/** 打开弹窗 */
const open = async (id,openType) => {
  resetForm()
  // 设置数据
  formData.value.id = id
  getDetail(id)
  dialogVisible.value = true
  // 如果openType是DetailOpen则是从详情页打开的，不需要显示表单，否则从首页快捷方式打开的需要显示表单
  if(openType=='DetailOpen'){
    showDetail.value = false
  }
}
const getDetail = async (id) => {
    if (id) {
      const res = (await TradeOrderApi.getOrder(id)) as TradeOrderApi.OrderVO
      // 没有表单信息则关闭页面返回
      if (!res) {
        message.error('交易订单不存在')
        close()
      }
      formData.value = res
    }
  }
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 提交请求
  formLoading.value = true
  try {
    const data = unref(formData)
    await TradeOrderApi.updateOrderRemark(data)
    message.success(t('common.updateSuccess'))
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success', true)
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: 0, // 订单编号
    remark: '' // 订单备注
  }
  formRef.value?.resetFields()
}
</script>
<style scoped lang="scss">
  ::v-deep .el-dialog__body{
    padding: 10px;
  }
</style>